#ifndef HASH_MAP
#undef GCC_VERSION
#define GCC_VERSION (__GNUC__ * 10000 \
                               + __GNUC_MINOR__ * 100 \
                               + __GNUC_PATCHLEVEL__)
/* Test for GCC >= 4.2.0 */
#if GCC_VERSION >= 40200
#define HASH_MAP unordered_map
#include <tr1/unordered_map>

#define HASH_SET unordered_set
#include <tr1/unordered_set>

using namespace std::tr1;

#else
#include <ext/hash_map>
#define HASH_MAP hash_map
#include <ext/hash_set>
#define HASH_SET hash_set

using namespace __gnu_cxx;

#endif


#endif

