// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2013, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2013, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#include <watch_types.hpp>
#include <iostream>
using namespace hcsp;
using namespace std;

namespace hcsp {
std::ostream & operator<<(std::ostream & out,
                               watch_types::watch_type data)
{
    switch (data) {
      case watch_types::MODIFICATION_WATCH: out << "MODIFICATION_WATCH"; break;
      case watch_types::FINALIZATION_WATCH: out << "FINALIZATION_WATCH"; break;
      case watch_types::LOWER_BOUND_WATCH:  out << "LOWER_BOUND_WATCH";  break;
      case watch_types::UPPER_BOUND_WATCH:  out << "UPPER_BOUND_WATCH";  break;
    }
    return out;
}
}
