// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2013, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2013, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */

#ifndef HCSP_CONFIG_HPP_

#ifdef __WINNT
// Windows function GetProcessTimes
#  define HAS_GetProcessTimes

// Windows function CreateThread
#  define HAS_CreateThread

// Header windows.h
#  define HAS_WINDOWS_H
#else
// Set if the system can generate a SIGPROF signal.
#  define HAS_SIGPROF  
// Is there getrusage() and struct rusage
#  define HAS_RUSAGE
// Header sys/resource.h
#  define HAS_SYS_RESOURCE_H
// Header alloca.h
#  define HAS_ALLOCA_H
#endif

#define HCSP_CONFIG_HPP_



#endif // HCSP_CONFIG_HPP_
