// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2009, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2009, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#ifndef HCSP_VAR_PROXY_HPP_
#define HCSP_VAR_PROXY_HPP_
#include <utility>
#include <string>
namespace hcsp {
class Expr;
class Problem;
class VarProxy {
  public:
    VarProxy(const Expr &);
    Problem & GetProblem() const;
    std::pair<int,int> GetRange() const;
    std::string GetName() const;
};
}


#endif // HCSP_VAR_PROXY_HPP_
