// -*- c-basic-offset:4 -*-
/*  This file is part of HaifaCSP Constraint Solver.
 *  Copyright (C) 2009, Michael Veksler mickey.veksler@gmail.com
 *  Copyright (C) 2009, Technion Israel Institute of Technology
 * 
 *  Permission is granted to copy and use the source code, the library, and 
 *  the executable only for academic and evaluation purposes. For any other
 *  use, most notably commercial, you must request permission from the copyright
 *  holders.
 *  Any copy of derivative work must retain this copyright notice.
 */
#ifndef NDEBUG
#define NDEBUG
#endif
#include <iostream>
#include <utilities.hpp>
#include "test_utilities.hpp"

volatile int a1=1;
volatile int a2=2;

int main()
{
    BEGIN_TEST_MAIN;
    // All should be ignored because of NDEBUG
    HCSP_ASSERT(0);
    HCSP_ASSERT(1);
    HCSP_ASSERT(a1==a2+1);
    HCSP_ASSERT(a1==a2);
    END_TEST_MAIN;
}
